;    2012/10/20 familystar peterlin 
; add +/- , stop speed function
;  use delay 8.asm code 12loop slow 1~2sec => loop 15 to 30 loop
; io define 
; p3.0 red led , p3.1 green led ,
; p3.2 ~p3.5 step motor => p1.2~1.5   
; p3.2 =int0 
; p3.7  motor direct  , p1.7 normal/expert mode
; p3.4 speed up p3.5 speed dn , p1.0 p1.1 Vcc detect
; p3.3  halt by int1 pin
; p1.0/ 1.1 & p3.6 vcc detect
; p1.7=low speed_up  p1.6 speed_low 
; reg define
; r5~r7 delay loop , 
; r3  min-time loop   r4=loop 200 times  
; psw.5  int use flag bit 

; spped up/down use polling , but reverse or halt us int
;
        org 0h 
        jmp start
        org 3h  
        jmp sub_int0
        org 0bh
        jmp start
        org 13h
        jmp sub_int1
        org 1bh
        jmp start
        org 23h
        jmp start
        
        org 30h        
sub_int1: 
         clr p3.1
         call delay2         
         setb p3.1
         call delay3
         nop
         clr p3.1
         reti  
        
        org 50h
sub_int0:         
        mov 0a8h,#84h ; disable int0   
        clr p3.0    
        call delay2 
        setb p3.0
        cjne r1,#0,li1
        inc r1 ; loop=0 add r1
        clr p3.0        
        clr c
li1:    setb psw.5 ;set flag
        call delay2 
        setb p3.0  
        reti    
        
        org 120h   
start:	         
        mov 0a8h,#85h; IE en int0/1
        mov 88h,#0h; set int0/int1 edge trig
        mov 0b8h,#1h; int0 priority hi
        mov 81h,#3fh ;sp 
        mov r1,#0
        mov r0,#0
        mov r3,#0
        mov r4,#0
        mov r7,#9h
        ;jnb p3.6,start1 ; vcc > 4.5v p3.6=0
        ;call delay1 
        ;cpl p3.0 
        ;cpl p3.1 ; vcc < 4.5v case
        ;call delay1
        ;jmp start        
        
; main program start
start1:
        setb p3.0 
        call delay1a
        clr p3.0  ; flash red
        call delay1a
        setb p3.0
        call delay1a
        clr p3.0
        call delay1a
        setb p3.0
        clr p3.1
        call delay1a   
        setb p3.1 
        call delay1a
        clr p3.1     ; constant green 
normal:         
        jb  p3.7,loop1  ; p3.7=1 forward first
        jmp loop2
loop1:  ; forward first -> back fast    
        clr p3.1 
        setb p3.0    
        mov r3,#1dh   ; forward LOOP 15=0FH=n+1 -> 2012/10/4 29+1= 1dh +1 
l10:    mov r4,#32h ; 32h=50 1 cycle=200 step
l11:	jnb p3.4,fup
		jnb p3.5,fdn
		jmp l10a_1			
fup:	call nor_forup
		nop  ;cpl p3.0
        jmp l11a_2
fdn:	call nor_fordn
		nop  ;cpl p3.1
		jmp l11a_2
l10a_1:	
fok:	call nor_for
l11a_2:	djnz r4,l11        
        dec r3	
        jb psw.5,l12a				
		cjne r3,#3h,l10_a
		clr c
l10_a:  nop
        jc l10a  ; judge loop < 3 goto l10a
        jmp l10				
l10a:   mov r4,#32h ; 1 cycle=200 step
l11a:   cpl p3.1           
        mov p1,#10100001b  ; A_bar
		call delay1
		cpl p3.1   ; flash green led
		mov p1,#10000101b  ; B_bar
		call delay1
		mov p1,#10010001b ; A
		call delay1 
		mov p1,#10001001b ; B
		call delay1
		djnz r4,l11a
		dec r3
		cpl p3.0	
l10b:   mov r4,#32h ; loop =2	 1 cycle=200 step
l11b:   setb p3.0           
        mov p1,#10100001b  ; A_bar
		call delay1
		cpl p3.0            ; flash red + green
		mov p1,#10000101b  ; B_bar
		call delay1		 
		mov p1,#10010001b ; A
		call delay1 
		cpl p3.1             ; flash red + green
		mov p1,#10001001b ; B
		call delay1
		djnz r4,l11b
		dec r3
		setb p3.1 ; loop =1	 green Led off	
l10c:   mov r4,#32h ; 1 cycle=200 step
l11c:   cpl p3.0           
        mov p1,#10100001b  ; A_bar
		call delay1
		cpl p3.0           ; fast flash red led
		mov p1,#10000101b  ; B_bar
		call delay1
		cpl p3.0 
		mov p1,#10010001b ; A
		call delay1 
		cpl p3.0
		mov p1,#10001001b ; B
		call delay1
		cpl p3.0		 
		djnz r4,l11c
        dec r3
		mov r3,#1eh  ; loop=15 => 30 =1eh
		jmp l12
l12a:   clr p3.0   
        mov a,r3
        cpl a
        clr c
        subb a,#0f1h
        clr c         
        anl a,#0fh  
        mov r3,a 
        setb p3.1 ; run ok without this?                  
l12: 	mov r4,#32h  ; fast backward 200 step=1 cycle      
l13:	call fast_back     		
		djnz r4,l13
        djnz r3,l12
        jmp l17
l15: 	mov r4,#32h  ; fast backward 200 step=1 cycle 
        setb p3.1     	
l16:    call fast_back
		clr p3.0
		djnz r4,l16        
l17:    mov p1,#10000000b
        setb p3.0
        call delay2                
        setb p3.1
		setb p3.0	
        jmp l3


loop2:  ; backward first -> fast forward 
        clr p3.1
		mov r3,#1dh  ; loop=15=n+1 -> 30 LOOPS	 		
l20:	mov r4,#32h  ;backward 200 step=1 cycle 
l21:	jnb p3.4,bup
		jnb p3.5,bdn
		jmp l21_a
bup:	call nor_backup
		nop  ; cpl p3.0
		jmp l21a_2
bdn: 	call nor_backdn	
		nop  ; cpl p3.1
		jmp l21a_2
l21_a:	
bok:	call nor_back
l21a_2:	djnz r4,l21		
		dec r3	
        jb psw.5,l22a				
		cjne r3,#3h,l20_a
		clr c
l20_a:  nop
        jc l20a ; judge loop <3 
    	jmp l20			
l20a:	mov r4,#32h  ;backward 200 step=1 cycle  
l21a:   cpl p3.1		
    	mov p1,#10010001b  ; A
		call delay1 
		cpl p3.1         ; flash green led
		mov p1,#10000101b  ; B_bar
		call delay1
		mov p1,#10100001b ; A_bar
		call delay1
		mov p1,#10001001b ; B
		call delay1			
		dec r3
		djnz r4,l21a
		cpl p3.0
l20b:	mov r4,#32h  ; loop=2  		
l21b:	mov p1,#10010001b  ; A
		call delay1 
		cpl p3.0         ; flash red + green
		mov p1,#10000101b  ; B_bar
		call delay1
		mov p1,#10100001b ; A_bar
		call delay1 
		cpl p3.1        ; flash red + green
		mov p1,#10001001b ; B
		call delay1		
		djnz r4,l21b	
		dec r3			
		setb p3.1 ; loop =1	 green Led off
l20c:	mov r4,#32h  ; loop=1  		
l21c:	mov p1,#10010001b  ; A
		call delay1 
		cpl p3.0
		mov p1,#10000101b  ; B_bar
		call delay1
		cpl p3.0
		mov p1,#10100001b ; A_bar
		call delay1 
		cpl p3.0       ; fast red led
		mov p1,#10001001b ; B
		call delay1
		cpl p3.0
		djnz r4,l21c	
		dec r3 			
        mov r3,#1eh  ; fast forward
        jmp l22
l22a:   clr p3.0
        mov a,r3
        cpl a
        clr c
        subb a,#0f1h
        clr c              
		anl a,#0fh
		mov r3,a
        setb p3.1
l22:	mov r4,#32h      ; fast forward    
l23:	call fast_for
		djnz r4,l23
        djnz r3,l22
        jmp l27
l25:    mov r4,#32h
        setb p3.1
l26:    call fast_for
		clr p3.0
		djnz r4,l26        
l27:    mov p1,#10000000b
        setb p3.0
        call delay2        
        setb p3.0         			
		setb p3.1	
        jmp l3

l3:     clr p3.1
        clr p3.0
        clr psw.5
        clr 88h.2 ; clear t0 flag 
        setb p3.1 
        setb p3.0 
        call delay2
        cpl p3.0 
        cpl p3.1
        call delay2
        cpl p3.0
        cpl p3.1
        setb p3.6
        call delay2
        setb p3.0
        setb p3.1
        jmp start ; loop 

; main program ending

; sub call program 
fast_for:
        mov p1,#10100010b  ; A_bar
		call delay2
		mov p1,#10000110b  ; B_bar
		call delay2
		mov p1,#10010010b ; A
		call delay2 
		mov p1,#10001010b ; B
		call delay2		
		ret
	
fast_back:
    	mov p1,#10010010b ; A
		call delay2 
		mov p1,#10000110b ; B_bar
		call delay2
		mov p1,#10100010b ; A_bar
		call delay2 
		mov p1,#10001010b ; B
		call delay2
		ret
nor_back: 		
    	mov p1,#10010001b  ; A
		call delay1  
		mov p1,#10000101b  ; B_bar
		call delay1 
		mov p1,#10100001b ; A_bar
		call delay1  
		mov p1,#10001001b ; B
		call delay1 	
		ret
nor_backup: 		
    	mov p1,#10010001b  ; A
		call delay1up  
		mov p1,#10000101b  ; B_bar
		call delay1up 
		mov p1,#10100001b ; A_bar
		call delay1up  
		mov p1,#10001001b ; B
		call delay1up 	
		ret
nor_backdn: 		
    	mov p1,#10010001b  ; A
		call delay1dn  
		mov p1,#10000101b  ; B_bar
		call delay1dn 
		mov p1,#10100001b ; A_bar
		call delay1dn  
		mov p1,#10001001b ; B
		call delay1dn 	
		ret
		

nor_for:		
        mov p1,#10100001b  ; A_bar
		call delay1
		mov p1,#10000101b  ; B_bar
		call delay1
		mov p1,#10010001b ; A
		call delay1 
		mov p1,#10001001b ; B
		call delay1	
		ret	
nor_forup:		
        mov p1,#10100001b  ; A_bar
		call delay1up
		mov p1,#10000101b  ; B_bar
		call delay1up
		mov p1,#10010001b ; A
		call delay1up 
		mov p1,#10001001b ; B
		call delay1up	
		ret	
nor_fordn:		
        mov p1,#10100001b  ; A_bar
		call delay1dn
		mov p1,#10000101b  ; B_bar
		call delay1dn
		mov p1,#10010001b ; A
		call delay1dn
		mov p1,#10001001b ; B
		call delay1dn
		ret	
		
delay1: 
        mov r7,#9h
d10:	nop        
        mov r6,#55h ; 55h
d11:    nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop ; cpl p3.1
    	nop 
        mov r5,#7eh ;  
d12:    nop        
        djnz r5,d12
        djnz r6,d11
        nop	 
        djnz r7,d10
        ret 
        
delay1up: 
        mov r7,#4h
d10up:	nop ;cpl p3.0        
        mov r6,#55h ; 55h
d11up:  nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop ;cpl p3.0
    	nop 
        mov r5,#7eh ;  
d12up:  nop        
        djnz r5,d12
        djnz r6,d11
        nop	 
        djnz r7,d10
        nop ;clr p3.0
        ret 
        
delay1dn: 
        mov r7,#12h
d10dn:	nop        
        mov r6,#55h ; 55h
d11dn:  nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop ; cpl p3.0
    	nop 
        mov r5,#7eh ;  
d12dn:  nop        
        djnz r5,d12
        djnz r6,d11
        nop	 
        djnz r7,d10
        nop ; clr p3.0
        ret 
       
delay1a: 
        mov r7,#9h; 12h  diff 93us/step ? 
d10a:	nop        
        mov r6,#55h ; 55h
d11a:    nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
    	nop 
        mov r5,#7eh ;  
d12a:    nop        
        djnz r5,d12a
        djnz r6,d11a
        nop	 
        djnz r7,d10a
        ret 
       
delay2:         
        mov r6,#79h ;79h
d21:	nop
        mov r5,#35h  ; 65h
d22:    nop
        djnz r5,d22
        nop
        djnz r6,d21	     
        ret
        
delay3:         
        mov r6,#79h ;79h
d31:	nop
        mov r5,#95h  ; 65h
d32:    djnz r5,d32
        djnz r6,d31	     
        ret
        
     	end 	
